#!/usr/bin/php5

<?php
    include ("simpleparser.php");

    if (sizeof($argv) < 2) {
        echo "You must specify an HTML file as an argument.\n";
        return -1;
    }
    $source_path = $argv[1];
 
    $htmlText = file_get_contents($source_path);
    if (! $htmlText ) {
	echo "Error opening $source_path\n";
	return -1;
    }
    $parser = new SimpleParser($htmlText);
    while ($parser->nextNode()) {
	printf("%3d: ", $parser->LineNumber);
	printf("%3d", $parser->NodeNestingDepth);
	echo "|{$parser->NodeName}|{$parser->NodeSelfClosing}|{$parser->CData}";
	if ($parser->NodeAttributes) {
		echo " -- " . implode_with_keys(",", $parser->NodeAttributes, "'");
	}
	echo "\n";
	if ($parser->Errors) {
		echo "ERROR:\n\t";
		echo implode("\n\t", $parser->Errors);
		echo "\n";
		$parser->clearErrors();
	}
    }
    
function implode_with_keys($glue, $array, $valwrap='')
   {
       $ret = array();
	foreach($array AS $key => $value) {
		$ret[] = $key."=".$valwrap.$value.$valwrap;
	}
	return implode($glue, $ret);
   }
?>
